require 'redis'
require 'json'

module Fluent
  class RedoopOutput < Output
    Fluent::Plugin.register_output('redoop', self)

    # This method is called before starting.
    def configure(conf)
      super

      @redis = Redis.new(:host => "127.0.0.1", :port => 6379)

      params = {}
      params["key_1"] = conf["key_1"]
      params["key_2"] = conf["key_2"]

      puts "*********"
      puts params
      puts "*********"
    end

    # This method is called when starting.
    def start
      super
    end

    # This method is called when shutting down.
    def shutdown
      super
    end

    # This method is called when an event reaches Fluentd.
    # 'es' is a Fluent::EventStream object that includes multiple events.
    # You can use 'es.each {|time,record| ... }' to retrieve events.
    # 'chain' is an object that manages transactions. Call 'chain.next' at
    # appropriate points and rollback if it raises an exception.
    def emit(tag, es, chain)
      chain.next
      es.each {|time,record|
        score = Time.now.to_i
        @redis.zadd tag, score, record.to_json
        @redis.publish "mathematica", record.to_json
        # puts record
        $stderr.puts "OK!"
      }
    end
  end
end
